' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2002                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -------------------------------------------------------------------
' FVX Sample Program
' 2lvʕ\tH[
'
' 쐬 : D.Yamaguchi
'
'  : 2006/12/25 
'
' -------------------------------------------------------------------

Imports Microsoft
Imports FVDATASLib

Public Class frmBlobResult

    Private Const PI As Double = 3.14159265358979

    'SBlob
    Public intMaxBlobNo As Integer

    'ݕ\ĂBlobNo. (-1őS\)
    Private m_intBlobNo As Integer

    Private Sub frmBlobResult_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_intBlobNo = -1
        DrawAll()

    End Sub

    'I
    Private Sub btnExitForm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExitForm.Click

        Me.Close()

    End Sub

    '
    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click

        m_intBlobNo += 1
        If m_intBlobNo > intMaxBlobNo Then m_intBlobNo = intMaxBlobNo

        DrawOne(m_intBlobNo)

    End Sub

    'O
    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click

        m_intBlobNo -= 1
        If m_intBlobNo < -1 Then m_intBlobNo = -1

        If m_intBlobNo = -1 Then
            DrawAll()
        Else
            DrawOne(m_intBlobNo)
        End If

    End Sub

    'SBlob`
    Private Sub DrawAll()

        Dim pBlobResultGroup As New FvBlobResultGroup   '2lv
        Dim pPoint As New FvPoint                       'Blobԍ\p

        Dim i As Integer

        txtBlobNo.Text = "ALL"
        txtResult.Text = "Su[uF " & intMaxBlobNo + 1

        With frmMain
            .AxFvxDisplayEx1.ClearOverlay()

            '͈͂𔖐ŕ\
            .AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(192, 192, 255)
            .AxFvxDisplayEx1.DrawData(0, .m_ExeRegion)

            .AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)  'F
            .AxFvxDisplayEx1.FontColor = System.Drawing.Color.FromArgb(255, 0, 0) 'F

            'ʂ̎擾
            .AxFvxBlob1.GetResult(0, pBlobResultGroup)

            'dS_ƊOڒ``
            .AxFvxDisplayEx1.DrawData(0, pBlobResultGroup)

            For i = 0 To intMaxBlobNo
                'u[uԍԂŕ\
                pPoint.x = pBlobResultGroup.Item2(i).center_x
                pPoint.y = pBlobResultGroup.Item2(i).center_y
                .AxFvxDisplayEx1.DrawText(0, pPoint, i.ToString())
            Next
        End With

    End Sub

    '1Blob`
    Private Sub DrawOne(ByVal intNum As Integer)

        Dim pBlobResult As New FvBlobResult
        Dim dblAngle As Double 'ȉ~XΊpixj
        Dim pLine As New FvLine
        Dim pEllipse As New FvEllipse

        txtBlobNo.Text = intNum.ToString()

        With frmMain
            'I[o[Cʂ̏
            .AxFvxDisplayEx1.ClearOverlay()

            '͈͂𔖐ŕ\
            .AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(192, 192, 255)
            .AxFvxDisplayEx1.DrawData(0, .m_ExeRegion)

            'u[uڍ׏擾
            .AxFvxBlob1.GetResult(intNum, pBlobResult)
        End With

        'u[ȕڍׂȏeLXg{bNXɕ\
        txtResult.Text = _
            "܂܂Ȃʐ : " & VisualBasic.Format(pBlobResult.area, "0.00") & vbCrLf & _
            " : " & VisualBasic.Format(pBlobResult.hole_num, "0.00") & vbCrLf & _
            "͒ : " & VisualBasic.Format(pBlobResult.perim, "0.00") & vbCrLf & _
            "ȉ~厲 : " & VisualBasic.Format(pBlobResult.ellipse_long, "0.00") & vbCrLf & _
            "ȉ~ : " & VisualBasic.Format(pBlobResult.ellipse_short, "0.00") & vbCrLf & _
            "ȉ~XΊp : " & VisualBasic.Format(pBlobResult.ellipse_angle, "0.00") & vbCrLf & _
            "dSW : ( " & VisualBasic.Format(pBlobResult.center_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.center_y, "0.00") & " )" & vbCrLf & _
            "Xŏl : " & VisualBasic.Format(pBlobResult.x_min, "0.00") & vbCrLf & _
            "Xől : " & VisualBasic.Format(pBlobResult.x_max, "0.00") & vbCrLf & _
            "Yŏl : " & VisualBasic.Format(pBlobResult.y_min, "0.00") & vbCrLf & _
            "Yől : " & VisualBasic.Format(pBlobResult.y_max, "0.00") & vbCrLf & _
            "܂߂ʐ : " & VisualBasic.Format(pBlobResult.total_area, "0.00") & vbCrLf & _
            "Oڒ`  : ( " & VisualBasic.Format(pBlobResult.bounding_top_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_top_y, "0.00") & " )" & vbCrLf & _
            "Oڒ` E : ( " & VisualBasic.Format(pBlobResult.bounding_right_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_right_y, "0.00") & " )" & vbCrLf & _
            "Oڒ`  : ( " & VisualBasic.Format(pBlobResult.bounding_left_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_left_y, "0.00") & " )" & vbCrLf & _
            "Oڒ` E : ( " & VisualBasic.Format(pBlobResult.bounding_bottom_x, "0.00") & _
                " , " & VisualBasic.Format(pBlobResult.bounding_bottom_y, "0.00") & " )" & vbCrLf


        'F = 
        frmMain.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)

        'ȉ~
        pEllipse.angle = pBlobResult.ellipse_angle
        pEllipse.axis_x = pBlobResult.ellipse_long
        pEllipse.axis_y = pBlobResult.ellipse_short
        pEllipse.x = pBlobResult.center_x
        pEllipse.y = pBlobResult.center_y
        frmMain.AxFvxDisplayEx1.DrawData(0, pEllipse)

        'dSʂAȉ~̒yђZ̒
        ' dS_: ( x1, y1 )    ȉ~XΊp: ƂƁA̎
        ' - xsin + ycos + ( x1sin - y1cos ) = 0
        dblAngle = pBlobResult.ellipse_angle * PI / 180
        pLine.a = -System.Math.Sin(dblAngle)
        pLine.b = System.Math.Cos(dblAngle)
        pLine.c = (pBlobResult.center_x * System.Math.Sin(dblAngle)) - (pBlobResult.center_y * System.Math.Cos(dblAngle))
        frmMain.AxFvxDisplayEx1.DrawData(0, pLine)

        dblAngle = (pBlobResult.ellipse_angle + 90) * PI / 180
        pLine.a = -System.Math.Sin(dblAngle)
        pLine.b = System.Math.Cos(dblAngle)
        pLine.c = (pBlobResult.center_x * System.Math.Sin(dblAngle)) - (pBlobResult.center_y * System.Math.Cos(dblAngle))
        frmMain.AxFvxDisplayEx1.DrawData(0, pLine)

        'dS_ƊOڒ`̕`
        frmMain.AxFvxDisplayEx1.DrawData(0, pBlobResult)

    End Sub

End Class