' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2006                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2006/12/25 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '͈
    Public m_ExeRegion As New FvRectangle

    'xOioj
    Public m_intArrange As Integer

    Public m_blnFlag As Boolean = False

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'Fݒ
        With cmbColor
            .Items.Add("BLACK")
            .Items.Add("WHITE")
            .SelectedIndex = 0
        End With

        'o
        rbtArrange0.Checked = True
        m_intArrange = 0

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_ExeRegion.xs = -1
        m_ExeRegion.xe = -1
        m_ExeRegion.ys = -1
        m_ExeRegion.ye = -1

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImageGray.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImageGray.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImageGray.GetOcx())

        '2l\
        AxFvxChangeImage1.FixedLevel(AxFvxImageGray.GetOcx(), AxFvxImageBin.GetOcx(), 128)
        AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        AxFvxDisplayEx1.DrawData(0, m_ExeRegion)

        m_blnFlag = True

    End Sub

    'J摜捞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        Dim intBinLevel As Integer

        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        AxFvxVideo1.GrabSync(AxFvxImageGray.GetOcx())    '捞
        AxFvxChangeImage1.FixedLevel(AxFvxImageGray.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)
        AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '͈͂̐ݒ
    Private Sub btnExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_ExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImageBin.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_ExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_ExeRegion.xe < m_ExeRegion.xs Then
                dblTemp = m_ExeRegion.xs
                m_ExeRegion.xs = m_ExeRegion.xe
                m_ExeRegion.xe = dblTemp
            End If
            If m_ExeRegion.ye < m_ExeRegion.ys Then
                dblTemp = m_ExeRegion.ys
                m_ExeRegion.ys = m_ExeRegion.ye
                m_ExeRegion.ye = dblTemp
            End If

            AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            AxFvxDisplayEx1.DrawData(0, m_ExeRegion)
        End If

    End Sub

    '2l臒lύX
    Private Sub txtBinLevel_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtBinLevel.TextChanged

        Dim intBinLevel As Integer

        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        If m_blnFlag = True Then
            AxFvxChangeImage1.FixedLevel(AxFvxImageGray.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)
            AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())
        End If

    End Sub

    'ʃNA
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click

        txtExeTime.Text = ""
        AxFvxDisplayEx1.ClearOverlay()

    End Sub

    '2l臒l
    Private Sub txtBinLevel_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtBinLevel.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    'ʐωl
    Private Sub txtMinSize_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtMinSize.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    'ʐϏl
    Private Sub txtMaxSize_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtMaxSize.KeyPress

        'l̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    '2lvs
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim dblTime As Double   '
        Dim intErr As Integer   'G[ԍ
        Dim intCount As Integer 'Blob̌

        Dim intMinSize As Integer  'ŏʐ
        Dim intMaxSize As Integer  'őʐ
        Dim dblAngle As Double     ']p

        Dim frmBlobRslt As New frmBlobResult


        'ʏ
        AxFvxDisplayEx1.ClearOverlay()

        'ʐϒl`FbN
        If Integer.TryParse(txtMinSize.Text, intMinSize) = False Or intMinSize < 1 Then
            MsgBox("ŏʐϒl͂Pȏ̐lݒ肵Ă", , "p[^G[")
            Exit Sub
        End If
        If Integer.TryParse(txtMaxSize.Text, intMaxSize) = False Or intMinSize >= intMaxSize Then
            MsgBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă", , "p[^G[")
            Exit Sub
        End If

        'őEŏʐϐݒ
        AxFvxBlob1.MinSize = intMinSize
        AxFvxBlob1.MaxSize = intMaxSize

        ']p
        If Double.TryParse(txtAngle.Text, dblAngle) = False Or dblAngle < -180 Or dblAngle > 180 Then
            MsgBox("]p -180.0`180.0 ͈̔͂œ͂Ă", , "p[^G[")
            Exit Sub
        End If
        AxFvxBlob1.angle = dblAngle

        'ΏېFݒ
        If cmbColor.Text = "BLACK" Then
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.BLACK_COLOR
        Else
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.WHITE_COLOR
        End If

        'xOiojݒ
        AxFvxBlob1.Arrange = m_intArrange

        '͈͐ڐG
        If chkWndTouch.Checked = True Then
            AxFvxBlob1.WindowTouch = FVXCOMBLOBLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxBlob1.WindowTouch = FVXCOMBLOBLib.WINDOW_TOUCH_TYPE.OFF
        End If

        '͈͐ݒ
        AxFvxBlob1.SetInspectArea(m_ExeRegion)


        AxFvxPerformanceCounter1.StartCount()       'ԑJn
        '2lvs
        AxFvxBlob1.Execute(AxFvxImageBin.GetOcx(), intCount)
        AxFvxPerformanceCounter1.StopCount(dblTime)    'ԑI

        'G[oĂ邩mF
        'VBWErrIuWFNgł̓G[ԍ擾ł܂
        'KGetErrReport\bhgăG[ԍ擾Ă
        AxFvxBlob1.GetErrReport(intErr)

        If intErr = 0 Then
            txtExeTime.Text = VisualBasic.Format(dblTime, "0.00ms")

            'ʕ\tH[
            frmBlobRslt.intMaxBlobNo = intCount - 1
            frmBlobRslt.ShowDialog()
        Else
            MsgBox("G[:" & intErr, vbExclamation, "G[")
        End If

    End Sub

    '摜Ǎ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        Dim intErr As Integer

        Dim intBinLevel As Integer
        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then
            'FileAccessR|[lgpāA
            't@CImageɉ摜ǂݍ݂܂
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImageTemp.GetOcx())
            Catch ex As System.Exception
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImageTemp.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray _
                Or AxFvxImageTemp.ImageWidth <> 512 Or AxFvxImageTemp.ImageHeight <> 480 Then
                MsgBox("512*480 1/8bitOC̉摜ł͂܂", , "error")

                AxFvxImageTemp.BitPerPixel = 8
                AxFvxImageTemp.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImageTemp.ImageWidth = 512
                AxFvxImageTemp.ImageHeight = 480
            End If

            'QlZW
            If AxFvxImageTemp.BitPerPixel = 1 Then
                AxFvxImageGray.ClearImage()
                AxFvxImageTemp.CopyTo(AxFvxImageBin.GetOcx())
                AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

            ElseIf AxFvxImageTemp.BitPerPixel = 8 Then
                AxFvxImageTemp.CopyTo(AxFvxImageGray.GetOcx())
                AxFvxChangeImage1.FixedLevel(AxFvxImageGray.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)
                AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

            Else
                MsgBox("1bit/8bitȊObmpł", , "ǍG[")
            End If

        End If

    End Sub

    '2l摜ۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImageBin.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    Private Sub rbtArrange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtArrange7.Click, rbtArrange6.Click, rbtArrange5.Click, rbtArrange4.Click, rbtArrange3.Click, rbtArrange2.Click, rbtArrange1.Click, rbtArrange0.Click

        Dim strTemp As String

        strTemp = VisualBasic.Right(sender.name, 1)
        m_intArrange = Integer.Parse(strTemp)

    End Sub
End Class
